var Assert = require('@kingjs/assert');

var Bootstrap = require('./bootstrap');
var defineConstHiddenProperty = Bootstrap.defineConstHiddenProperty;

function pathReplace(func, target, path, index, name) {
  if (!target || !path || path.length == 0)
    return target;

  if (!index)
    index = 0;
  
  if (!name)
    name = path[index];
  
  Assert.that(name == path[index] || path[index] == '*');
  
  if (name == '*') {
    for (var property in target) 
      pathReplace(func, target, path, index, property);
    return target;
  }
  
  if (index++ < path.length - 1)
    pathReplace(func, target[name], path, index, path[index]);
  
  else    
    target[name] = func(target[name]);
  
  return target;
}
defineConstHiddenProperty(module, 'exports', pathReplace);